<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eicd: src/MCParticleCollection.cc Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eicd
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">MCParticleCollection.cc</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_m_c_particle_collection_8cc.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// AUTOMATICALLY GENERATED FILE - DO NOT EDIT</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_m_c_particle_collection_8h.html">eicd/MCParticleCollection.h</a>&quot;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;</div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_m_c_particle_collection_8h.html">eicd/MCParticleCollection.h</a>&quot;</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">// standard includes</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;stdexcept&gt;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;iomanip&gt;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceeic.html">eic</a> {</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#ac3995c35eeaa892609088efcf137e154">   14</a></span>&#160;<a class="code" href="classeic_1_1_m_c_particle_collection.html#ac3995c35eeaa892609088efcf137e154">MCParticleCollection::MCParticleCollection</a>() :</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;  m_isValid(false), m_collectionID(0), m_entries(),</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;  m_rel_parents(new std::vector&lt;<a class="code" href="namespaceeic.html">eic</a>::<a class="code" href="classeic_1_1_const_m_c_particle.html">ConstMCParticle</a>&gt;()),</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;  m_rel_daughters(new std::vector&lt;<a class="code" href="namespaceeic.html">eic</a>::<a class="code" href="classeic_1_1_const_m_c_particle.html">ConstMCParticle</a>&gt;()),</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;  m_data(new <a class="code" href="namespaceeic.html#a5bd8e90bfeab64c62afd20fef747150d">MCParticleDataContainer</a>()) {</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;  m_refCollections.push_back(<span class="keyword">new</span> std::vector&lt;podio::ObjectID&gt;());</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;  m_refCollections.push_back(<span class="keyword">new</span> std::vector&lt;podio::ObjectID&gt;());</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;}</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a6294d25b30fba6f6ddf2bf8dda5508e3">   23</a></span>&#160;<a class="code" href="classeic_1_1_m_c_particle_collection.html#a6294d25b30fba6f6ddf2bf8dda5508e3">MCParticleCollection::~MCParticleCollection</a>() {</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;  <a class="code" href="classeic_1_1_m_c_particle_collection.html#aa4953ac999ea603fd189d4cee61f1515">clear</a>();</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;  <span class="keywordflow">if</span> (m_data) <span class="keyword">delete</span> m_data;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; pointer : m_refCollections) { <span class="keywordflow">if</span> (pointer) <span class="keyword">delete</span> pointer; }</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;  <span class="keywordflow">if</span> (m_rel_parents) <span class="keyword">delete</span> m_rel_parents;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;  <span class="keywordflow">if</span> (m_rel_daughters) <span class="keyword">delete</span> m_rel_daughters;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;}</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#ae517894a019538acb6e3f26dc472a798">   31</a></span>&#160;<span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> <a class="code" href="classeic_1_1_m_c_particle_collection.html#ae517894a019538acb6e3f26dc472a798">MCParticleCollection::operator[]</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)<span class="keyword"> const </span>{</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;  <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a>(m_entries[index]);</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;}</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#aeab9117d36eab9f2d798f989a668c087">   35</a></span>&#160;<span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> <a class="code" href="classeic_1_1_m_c_particle_collection.html#aeab9117d36eab9f2d798f989a668c087">MCParticleCollection::at</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)<span class="keyword"> const </span>{</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;  <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a>(m_entries.at(index));</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;}</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#af1780482927898328c3dc4ecf1682547">   39</a></span>&#160;<a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> <a class="code" href="classeic_1_1_m_c_particle_collection.html#ae517894a019538acb6e3f26dc472a798">MCParticleCollection::operator[]</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) {</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;  <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a>(m_entries[index]);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;}</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a7f2616873211f20e8b8645b9a3d8e742">   43</a></span>&#160;<a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> <a class="code" href="classeic_1_1_m_c_particle_collection.html#aeab9117d36eab9f2d798f989a668c087">MCParticleCollection::at</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) {</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;  <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a>(m_entries.at(index));</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;}</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">   47</a></span>&#160;<span class="keywordtype">size_t</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">MCParticleCollection::size</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;  <span class="keywordflow">return</span> m_entries.size();</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;}</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#ab6428411972f6aeeeee160650ebbe15d">   51</a></span>&#160;<a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> <a class="code" href="classeic_1_1_m_c_particle_collection.html#ab6428411972f6aeeeee160650ebbe15d">MCParticleCollection::create</a>() {</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;  <span class="keyword">auto</span> obj = m_entries.emplace_back(<span class="keyword">new</span> <a class="code" href="classeic_1_1_m_c_particle_obj.html">MCParticleObj</a>());</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;  m_rel_parents_tmp.push_back(obj-&gt;m_parents);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  m_rel_daughters_tmp.push_back(obj-&gt;m_daughters);</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;  obj-&gt;id = {int(m_entries.size() - 1), m_collectionID};</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;  <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a>(obj);</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;}</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#aa4953ac999ea603fd189d4cee61f1515">   60</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html#aa4953ac999ea603fd189d4cee61f1515">MCParticleCollection::clear</a>() {</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;  m_data-&gt;clear();</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; pointer : m_refCollections) { pointer-&gt;clear(); }</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;  <span class="comment">// clear relations to parents. Make sure to unlink() the reference data as they may be gone already.</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; pointer : m_rel_parents_tmp) {</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; item : *pointer) {</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;      item.unlink();</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    }</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">delete</span> pointer;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  }</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  m_rel_parents_tmp.clear();</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; item : (*m_rel_parents)) { item.unlink(); }</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;  m_rel_parents-&gt;clear();</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;  <span class="comment">// clear relations to daughters. Make sure to unlink() the reference data as they may be gone already.</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; pointer : m_rel_daughters_tmp) {</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; item : *pointer) {</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;      item.unlink();</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    }</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keyword">delete</span> pointer;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;  }</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;  m_rel_daughters_tmp.clear();</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; item : (*m_rel_daughters)) { item.unlink(); }</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;  m_rel_daughters-&gt;clear();</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; obj : m_entries) { <span class="keyword">delete</span> obj; }</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;  m_entries.clear();</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;}</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a83cae41a1ac3b11258297be95d2257ff">   89</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html#a83cae41a1ac3b11258297be95d2257ff">MCParticleCollection::prepareForWrite</a>() {</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a> = m_entries.size();</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;  m_data-&gt;reserve(<a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a>);</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; obj : m_entries) { m_data-&gt;push_back(obj-&gt;data); }</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; pointer : m_refCollections) { pointer-&gt;clear(); }</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;  <span class="keywordtype">int</span> parents_index = 0;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;  <span class="keywordtype">int</span> daughters_index = 0;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0, <a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a> = m_data-&gt;size(); i != <a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a>; ++i) {</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    (*m_data)[i].parents_begin = parents_index;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    (*m_data)[i].parents_end += parents_index;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    parents_index = (*m_data)[i].parents_end;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; it : (*m_rel_parents_tmp[i])) {</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;      <span class="keywordflow">if</span> (it.getObjectID().index == podio::ObjectID::untracked) {</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keywordflow">throw</span> std::runtime_error(<span class="stringliteral">&quot;Trying to persistify untracked object&quot;</span>);</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;      }</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;      m_refCollections[0]-&gt;emplace_back(it.getObjectID());</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;      m_rel_parents-&gt;push_back(it);</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    }</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    (*m_data)[i].daughters_begin = daughters_index;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    (*m_data)[i].daughters_end += daughters_index;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    daughters_index = (*m_data)[i].daughters_end;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; it : (*m_rel_daughters_tmp[i])) {</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;      <span class="keywordflow">if</span> (it.getObjectID().index == podio::ObjectID::untracked) {</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        <span class="keywordflow">throw</span> std::runtime_error(<span class="stringliteral">&quot;Trying to persistify untracked object&quot;</span>);</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;      }</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;      m_refCollections[1]-&gt;emplace_back(it.getObjectID());</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;      m_rel_daughters-&gt;push_back(it);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    }</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;  }</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;}</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#aa3ff99a26b79b06a1ced722045c6b987">  123</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html#aa3ff99a26b79b06a1ced722045c6b987">MCParticleCollection::prepareAfterRead</a>() {</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;  <span class="keywordtype">int</span> index = 0;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; data : *m_data) {</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="keyword">auto</span> obj = <span class="keyword">new</span> <a class="code" href="classeic_1_1_m_c_particle_obj.html">MCParticleObj</a>({index, m_collectionID}, data);</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    obj-&gt;<a class="code" href="classeic_1_1_m_c_particle_obj.html#abbeab95552f7def689dcba8b080c44f3">m_parents</a> = m_rel_parents;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    obj-&gt;m_daughters = m_rel_daughters;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    m_entries.emplace_back(obj);</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    ++index;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;  }</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;  m_isValid = <span class="keyword">true</span>;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;}</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00136"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a6eb63ec10143c12746773152acc00fb7">  136</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html#a6eb63ec10143c12746773152acc00fb7">MCParticleCollection::setReferences</a>(<span class="keyword">const</span> podio::ICollectionProvider* collectionProvider) {</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0, <a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a> = m_refCollections[0]-&gt;<a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a>(); i != <a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a>; ++i) {</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    <span class="keyword">const</span> <span class="keyword">auto</span> <span class="keywordtype">id</span> = (*m_refCollections[0])[i];</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="keywordflow">if</span> (<span class="keywordtype">id</span>.index != podio::ObjectID::invalid) {</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;      CollectionBase* coll = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;      collectionProvider-&gt;get(<span class="keywordtype">id</span>.collectionID, coll);</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;      <a class="code" href="classeic_1_1_m_c_particle_collection.html">eic::MCParticleCollection</a>* tmp_coll = <span class="keyword">static_cast&lt;</span><a class="code" href="classeic_1_1_m_c_particle_collection.html">eic::MCParticleCollection</a>*<span class="keyword">&gt;</span>(coll);</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;      <span class="keyword">const</span> <span class="keyword">auto</span> tmp = (*tmp_coll)[<span class="keywordtype">id</span>.index];</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;      m_rel_parents-&gt;emplace_back(tmp);</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;      m_rel_parents-&gt;emplace_back(<span class="keyword">nullptr</span>);</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    }</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;  }</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0, <a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a> = m_refCollections[1]-&gt;<a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a>(); i != <a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a>; ++i) {</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <span class="keyword">const</span> <span class="keyword">auto</span> <span class="keywordtype">id</span> = (*m_refCollections[1])[i];</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="keywordflow">if</span> (<span class="keywordtype">id</span>.index != podio::ObjectID::invalid) {</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;      CollectionBase* coll = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;      collectionProvider-&gt;get(<span class="keywordtype">id</span>.collectionID, coll);</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;      <a class="code" href="classeic_1_1_m_c_particle_collection.html">eic::MCParticleCollection</a>* tmp_coll = <span class="keyword">static_cast&lt;</span><a class="code" href="classeic_1_1_m_c_particle_collection.html">eic::MCParticleCollection</a>*<span class="keyword">&gt;</span>(coll);</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;      <span class="keyword">const</span> <span class="keyword">auto</span> tmp = (*tmp_coll)[<span class="keywordtype">id</span>.index];</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;      m_rel_daughters-&gt;emplace_back(tmp);</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;      m_rel_daughters-&gt;emplace_back(<span class="keyword">nullptr</span>);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    }</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;  }</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;  <span class="keywordflow">return</span> <span class="keyword">true</span>; <span class="comment">//TODO: check success</span></div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;}</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div><div class="line"><a name="l00167"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a480180b4b9a245ea743a050e75d931a0">  167</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html#a480180b4b9a245ea743a050e75d931a0">MCParticleCollection::push_back</a>(<a class="code" href="classeic_1_1_const_m_c_particle.html">ConstMCParticle</a> <span class="keywordtype">object</span>) {</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;  <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a> = m_entries.size();</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;  <span class="keyword">auto</span> obj = <span class="keywordtype">object</span>.m_obj;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;  <span class="keywordflow">if</span> (obj-&gt;id.index == podio::ObjectID::untracked) {</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    obj-&gt;id = {<a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a>, m_collectionID};</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    m_entries.push_back(obj);</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    m_rel_parents_tmp.push_back(obj-&gt;m_parents);</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    m_rel_daughters_tmp.push_back(obj-&gt;m_daughters);</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;  } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <span class="keywordflow">throw</span> std::invalid_argument(<span class="stringliteral">&quot;Object already in a collection. Cannot add it to a second collection&quot;</span>);</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;  }</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;}</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div><div class="line"><a name="l00181"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection.html#a963e0b16e97a1f661a9ddb18c35a9635">  181</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html#a963e0b16e97a1f661a9ddb18c35a9635">MCParticleCollection::setBuffer</a>(<span class="keywordtype">void</span>* address) {</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;  <span class="keywordflow">if</span> (m_data) <span class="keyword">delete</span> m_data;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;  m_data = <span class="keyword">static_cast&lt;</span><a class="code" href="namespaceeic.html#a5bd8e90bfeab64c62afd20fef747150d">MCParticleDataContainer</a>*<span class="keyword">&gt;</span>(address);</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;}</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;</div><div class="line"><a name="l00186"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection_iterator.html#a18cfe3aa4eff0cc87907c9c6143770c9">  186</a></span>&#160;<span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a> <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html#a18cfe3aa4eff0cc87907c9c6143770c9">MCParticleCollectionIterator::operator*</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;  m_object.m_obj = (*m_collection)[m_index];</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;  <span class="keywordflow">return</span> m_object;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;}</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection_iterator.html#af6248ebaba9075fcf9752608c95a9bff">  191</a></span>&#160;<span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle.html">MCParticle</a>* <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html#af6248ebaba9075fcf9752608c95a9bff">MCParticleCollectionIterator::operator-&gt;</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;  m_object.m_obj = (*m_collection)[m_index];</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;  <span class="keywordflow">return</span> &amp;m_object;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;}</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div><div class="line"><a name="l00196"></a><span class="lineno"><a class="line" href="classeic_1_1_m_c_particle_collection_iterator.html#a135e791096be03f92c8ae6caaea014e5">  196</a></span>&#160;<span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html">MCParticleCollectionIterator</a>&amp; <a class="code" href="classeic_1_1_m_c_particle_collection_iterator.html#a135e791096be03f92c8ae6caaea014e5">MCParticleCollectionIterator::operator++</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;  ++m_index;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;  <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;}</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div><div class="line"><a name="l00201"></a><span class="lineno"><a class="line" href="namespaceeic.html#a08af87474fae902ccf0fb2efa42ec484">  201</a></span>&#160;std::ostream&amp; <a class="code" href="namespaceeic.html#a207cb16b7a2df08e82d05c73c144487f">operator&lt;&lt;</a>(std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classeic_1_1_m_c_particle_collection.html">MCParticleCollection</a>&amp; v) {</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> old_flags = o.flags();</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;  o &lt;&lt; <span class="stringliteral">&quot;          id:         pdg:   genstatus:      vertex:      charge:        mass:        time:    endpoint: endpointSet:    momentum:&quot;</span> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; v.<a class="code" href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">size</a>(); ++i) {</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    o &lt;&lt; std::scientific &lt;&lt; std::showpos &lt;&lt; std::setw(12) &lt;&lt; v[i].id() &lt;&lt; <span class="stringliteral">&quot; &quot;</span></div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;      &lt;&lt; std::setw(12) &lt;&lt; v[i].<a class="code" href="classeic_1_1_m_c_particle_collection.html#a90e403a5b70fb3830d8a7aea4709ff3d">pdg</a>() &lt;&lt; <span class="stringliteral">&quot; &quot;</span></div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;      &lt;&lt; std::setw(12) &lt;&lt; v[i].<a class="code" href="classeic_1_1_m_c_particle_collection.html#abd8a939f84ae2dddefcc85f14c29fdef">genstatus</a>() &lt;&lt; <span class="stringliteral">&quot; &quot;</span></div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;      &lt;&lt; std::setw(12) &lt;&lt; v[i].<a class="code" href="classeic_1_1_m_c_particle_collection.html#ae2446dc823db49fa808d753766a2199e">charge</a>() &lt;&lt; <span class="stringliteral">&quot; &quot;</span></div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;      &lt;&lt; std::setw(12) &lt;&lt; v[i].<a class="code" href="classeic_1_1_m_c_particle_collection.html#adf4952a746cf61e5cd3ec67846cdf85e">mass</a>() &lt;&lt; <span class="stringliteral">&quot; &quot;</span></div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;      &lt;&lt; std::setw(12) &lt;&lt; v[i].<a class="code" href="classeic_1_1_m_c_particle_collection.html#ad96bb16d20528007e19b51b8714d7875">time</a>() &lt;&lt; <span class="stringliteral">&quot; &quot;</span></div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;      &lt;&lt; std::setw(12) &lt;&lt; v[i].<a class="code" href="classeic_1_1_m_c_particle_collection.html#a1f6d48898d33f82ea76c6112b913605d">endpointSet</a>() &lt;&lt; <span class="stringliteral">&quot; &quot;</span></div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;      &lt;&lt; std::endl;</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    o &lt;&lt; <span class="stringliteral">&quot;      parents : &quot;</span>;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> j = 0, N = v[i].parents_size(); j &lt; N; ++j) {</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;      o &lt;&lt; v[i].parents(j).id() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    }</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    o &lt;&lt; std::endl;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    o &lt;&lt; <span class="stringliteral">&quot;      daughters : &quot;</span>;</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> j = 0, N = v[i].daughters_size(); j &lt; N; ++j) {</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;      o &lt;&lt; v[i].daughters(j).id() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    }</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    o &lt;&lt; std::endl;</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;  }</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;  o.flags(old_flags);</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;  <span class="keywordflow">return</span> o;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;}</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;} <span class="comment">// namespace eic</span></div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;</div><div class="ttc" id="classeic_1_1_m_c_particle_html"><div class="ttname"><a href="classeic_1_1_m_c_particle.html">eic::MCParticle</a></div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_8h_source.html#l00028">MCParticle.h:28</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a90e403a5b70fb3830d8a7aea4709ff3d"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a90e403a5b70fb3830d8a7aea4709ff3d">eic::MCParticleCollection::pdg</a></div><div class="ttdeci">const std::array&lt; long long, arraysize &gt; pdg() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00178">MCParticleCollection.h:178</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_aa4953ac999ea603fd189d4cee61f1515"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#aa4953ac999ea603fd189d4cee61f1515">eic::MCParticleCollection::clear</a></div><div class="ttdeci">void clear() override final</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00060">MCParticleCollection.cc:60</a></div></div>
<div class="ttc" id="namespaceeic_html_a5bd8e90bfeab64c62afd20fef747150d"><div class="ttname"><a href="namespaceeic.html#a5bd8e90bfeab64c62afd20fef747150d">eic::MCParticleDataContainer</a></div><div class="ttdeci">std::vector&lt; MCParticleData &gt; MCParticleDataContainer</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00026">MCParticleCollection.h:26</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_obj_html"><div class="ttname"><a href="classeic_1_1_m_c_particle_obj.html">eic::MCParticleObj</a></div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_obj_8h_source.html#l00020">MCParticleObj.h:20</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_ab6428411972f6aeeeee160650ebbe15d"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#ab6428411972f6aeeeee160650ebbe15d">eic::MCParticleCollection::create</a></div><div class="ttdeci">MCParticle create()</div><div class="ttdoc">Append a new object to the collection, and return this object. </div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00051">MCParticleCollection.cc:51</a></div></div>
<div class="ttc" id="classeic_1_1_const_m_c_particle_html"><div class="ttname"><a href="classeic_1_1_const_m_c_particle.html">eic::ConstMCParticle</a></div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_const_8h_source.html#l00026">MCParticleConst.h:26</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_ad96bb16d20528007e19b51b8714d7875"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#ad96bb16d20528007e19b51b8714d7875">eic::MCParticleCollection::time</a></div><div class="ttdeci">const std::array&lt; float, arraysize &gt; time() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00228">MCParticleCollection.h:228</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_aa3ff99a26b79b06a1ced722045c6b987"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#aa3ff99a26b79b06a1ced722045c6b987">eic::MCParticleCollection::prepareAfterRead</a></div><div class="ttdeci">void prepareAfterRead() override final</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00123">MCParticleCollection.cc:123</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_aeab9117d36eab9f2d798f989a668c087"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#aeab9117d36eab9f2d798f989a668c087">eic::MCParticleCollection::at</a></div><div class="ttdeci">const MCParticle at(unsigned int index) const</div><div class="ttdoc">Returns the const object of given index. </div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00035">MCParticleCollection.cc:35</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_adf4952a746cf61e5cd3ec67846cdf85e"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#adf4952a746cf61e5cd3ec67846cdf85e">eic::MCParticleCollection::mass</a></div><div class="ttdeci">const std::array&lt; float, arraysize &gt; mass() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00218">MCParticleCollection.h:218</a></div></div>
<div class="ttc" id="namespaceeic_html_a207cb16b7a2df08e82d05c73c144487f"><div class="ttname"><a href="namespaceeic.html#a207cb16b7a2df08e82d05c73c144487f">eic::operator&lt;&lt;</a></div><div class="ttdeci">std::ostream &amp; operator&lt;&lt;(std::ostream &amp;o, const ConstCalorimeterHit &amp;value)</div><div class="ttdef"><b>Definition:</b> <a href="_calorimeter_hit_8cc_source.html#l00112">CalorimeterHit.cc:112</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a6eb63ec10143c12746773152acc00fb7"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a6eb63ec10143c12746773152acc00fb7">eic::MCParticleCollection::setReferences</a></div><div class="ttdeci">bool setReferences(const podio::ICollectionProvider *collectionProvider) override final</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00136">MCParticleCollection.cc:136</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_ae1d31364d12051e7bcb46a194aaf7b76"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#ae1d31364d12051e7bcb46a194aaf7b76">eic::MCParticleCollection::size</a></div><div class="ttdeci">size_t size() const override final</div><div class="ttdoc">number of elements in the collection </div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00047">MCParticleCollection.cc:47</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_iterator_html_a18cfe3aa4eff0cc87907c9c6143770c9"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection_iterator.html#a18cfe3aa4eff0cc87907c9c6143770c9">eic::MCParticleCollectionIterator::operator*</a></div><div class="ttdeci">const MCParticle operator*() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00186">MCParticleCollection.cc:186</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_iterator_html"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection_iterator.html">eic::MCParticleCollectionIterator</a></div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00029">MCParticleCollection.h:29</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a1f6d48898d33f82ea76c6112b913605d"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a1f6d48898d33f82ea76c6112b913605d">eic::MCParticleCollection::endpointSet</a></div><div class="ttdeci">const std::array&lt; bool, arraysize &gt; endpointSet() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00248">MCParticleCollection.h:248</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_ae517894a019538acb6e3f26dc472a798"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#ae517894a019538acb6e3f26dc472a798">eic::MCParticleCollection::operator[]</a></div><div class="ttdeci">const MCParticle operator[](unsigned int index) const</div><div class="ttdoc">Returns the const object of given index. </div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00031">MCParticleCollection.cc:31</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a6294d25b30fba6f6ddf2bf8dda5508e3"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a6294d25b30fba6f6ddf2bf8dda5508e3">eic::MCParticleCollection::~MCParticleCollection</a></div><div class="ttdeci">~MCParticleCollection()</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00023">MCParticleCollection.cc:23</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html">eic::MCParticleCollection</a></div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00050">MCParticleCollection.h:50</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_ac3995c35eeaa892609088efcf137e154"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#ac3995c35eeaa892609088efcf137e154">eic::MCParticleCollection::MCParticleCollection</a></div><div class="ttdeci">MCParticleCollection()</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00014">MCParticleCollection.cc:14</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_iterator_html_af6248ebaba9075fcf9752608c95a9bff"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection_iterator.html#af6248ebaba9075fcf9752608c95a9bff">eic::MCParticleCollectionIterator::operator-&gt;</a></div><div class="ttdeci">const MCParticle * operator-&gt;() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00191">MCParticleCollection.cc:191</a></div></div>
<div class="ttc" id="namespaceeic_html"><div class="ttname"><a href="namespaceeic.html">eic</a></div><div class="ttdef"><b>Definition:</b> <a href="_calorimeter_hit_8cc_source.html#l00014">CalorimeterHit.cc:14</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_iterator_html_a135e791096be03f92c8ae6caaea014e5"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection_iterator.html#a135e791096be03f92c8ae6caaea014e5">eic::MCParticleCollectionIterator::operator++</a></div><div class="ttdeci">const MCParticleCollectionIterator &amp; operator++() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00196">MCParticleCollection.cc:196</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a963e0b16e97a1f661a9ddb18c35a9635"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a963e0b16e97a1f661a9ddb18c35a9635">eic::MCParticleCollection::setBuffer</a></div><div class="ttdeci">void setBuffer(void *address) override final</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00181">MCParticleCollection.cc:181</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_ae2446dc823db49fa808d753766a2199e"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#ae2446dc823db49fa808d753766a2199e">eic::MCParticleCollection::charge</a></div><div class="ttdeci">const std::array&lt; float, arraysize &gt; charge() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00208">MCParticleCollection.h:208</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_obj_html_abbeab95552f7def689dcba8b080c44f3"><div class="ttname"><a href="classeic_1_1_m_c_particle_obj.html#abbeab95552f7def689dcba8b080c44f3">eic::MCParticleObj::m_parents</a></div><div class="ttdeci">std::vector&lt;::eic::ConstMCParticle &gt; * m_parents</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_obj_8h_source.html#l00033">MCParticleObj.h:33</a></div></div>
<div class="ttc" id="_m_c_particle_collection_8h_html"><div class="ttname"><a href="_m_c_particle_collection_8h.html">MCParticleCollection.h</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a480180b4b9a245ea743a050e75d931a0"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a480180b4b9a245ea743a050e75d931a0">eic::MCParticleCollection::push_back</a></div><div class="ttdeci">void push_back(ConstMCParticle object)</div><div class="ttdoc">Append object to the collection. </div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00167">MCParticleCollection.cc:167</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_a83cae41a1ac3b11258297be95d2257ff"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#a83cae41a1ac3b11258297be95d2257ff">eic::MCParticleCollection::prepareForWrite</a></div><div class="ttdeci">void prepareForWrite() override final</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8cc_source.html#l00089">MCParticleCollection.cc:89</a></div></div>
<div class="ttc" id="classeic_1_1_m_c_particle_collection_html_abd8a939f84ae2dddefcc85f14c29fdef"><div class="ttname"><a href="classeic_1_1_m_c_particle_collection.html#abd8a939f84ae2dddefcc85f14c29fdef">eic::MCParticleCollection::genstatus</a></div><div class="ttdeci">const std::array&lt; long long, arraysize &gt; genstatus() const</div><div class="ttdef"><b>Definition:</b> <a href="_m_c_particle_collection_8h_source.html#l00188">MCParticleCollection.h:188</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
